#!/bin/bash
#
# Be sure to set up $NEW_MAS, $OLD_MAS, and $PATCH_FILE.
#
# You can probably run this script from rc.local.
#

NEW_MAS=$HOME/code/mas/branch/driver_hacking/
OLD_MAS=$HOME/code/mas/trunk/

PATCH_FILE=$NEW_MAS/U0107_140424.dsp


DSP_CMD=$OLD_MAS/applications/dsp_cmd/dsp_cmd

function set_driver {
    ver=$1
    case $ver in 
	new)
	    sudo rmmod mce_dsp && sudo insmod $NEW_MAS/driver/mce_dsp.ko || return 1
	    sleep 0.5
	    sudo $NEW_MAS/scripts/mas_mknodes pci
	    ;;
	old)
	    sudo rmmod mce_dsp && sudo insmod $OLD_MAS/driver/mce_dsp.ko || return 1
	    sleep 0.5
	    sudo $OLD_MAS/scripts/mas_mknodes pci
	    ;;
    esac
}

function freeze {
    do=$1
    sleep 0.1
    case $do in
	1)
  # Freeze the loop
	    echo "Freezing..."
	    x=`$DSP_CMD -qx read x 0 | sed 's/.*=\ //g'`
	    x=$(( $x |  0x400000 ))
	    $DSP_CMD -qx write x 0 $x
	    ;;
	0)
	    echo "Thawing..."
  # Unfreeze the loop
	    x=`$DSP_CMD -qx read x 0 | sed 's/.*=\ //g'`
	    x=$(( $x & ~0x400000 & 0xffffff ))
	    $DSP_CMD -qx write x 0 $x
	    ;;
	*)
	    echo what
    esac
    sleep 0.1
}

function apply_patch {
    echo "Patching..."
    cat $PATCH_FILE | sed 's/.*qx\ //g'| $DSP_CMD -q
}


set_driver old && \
    sleep 1 && \
    freeze 1 && \
    sleep 1 && \
    apply_patch && \
    sleep 1 && \
    freeze 0 && \
    sleep 1 && \
    set_driver new

echo
echo "If you got three errors about 'mknod', it's no big deal."
echo
